#include "stdafx.h"
#include "Win32_GetCHMVersion.h"
#include "shellapi.h" // ShellExecute

// Suppress a couple of not essintial casting warnings.
#pragma warning(disable:4311)
#pragma warning(disable:4312)

#define MAX_LOADSTRING 100

// Global variables.
HINSTANCE hInst;							
TCHAR szTitle[MAX_LOADSTRING];				
TCHAR szWindowClass[MAX_LOADSTRING];		

// Forward declarations of functions included in this code module.
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

BOOL AboutDlg_OnInitDialog(HWND hDlg);

// These 3 declarations have no relation to getting CHM version.
WNDPROC g_wpOldWndProc;
void AboutDlg_SetFont(HWND hWnd);
LRESULT APIENTRY StaticSubclassedFunc(HWND hWnd,UINT Message,WPARAM wParam, 
							                                       LONG lParam);
int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings.
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_WIN32_GETCHMVERSION, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization.
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_WIN32_GETCHMVERSION);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}

ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_WIN32_GETCHMVERSION);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCTSTR)IDC_WIN32_GETCHMVERSION;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
                               500, 400, 400, 200, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		AboutDlg_OnInitDialog(hDlg);
		g_wpOldWndProc = (WNDPROC)SetWindowLong(GetDlgItem (hDlg, 
			        IDC_STATIC_LINK), GWL_WNDPROC, (DWORD)StaticSubclassedFunc);
		AboutDlg_SetFont(hDlg);
		return TRUE;
	case WM_CTLCOLORSTATIC:
		if (GetDlgItem (hDlg,IDC_STATIC_LINK) == 
			                        (HWND)lParam /* handle to static control */)
		{
			SetTextColor((HDC)wParam /* handle to display context */, 
				                                                  RGB(0,0,255));
			// Background is not changed when drawing a text.
			SetBkMode((HDC)wParam /* handle to display context */, TRANSPARENT); 
			// If the dialog box procedure returns FALSE, then default message 
			// handling is performed.
			return (BOOL)GetStockObject(HOLLOW_BRUSH); 
		}
        break;
	case WM_COMMAND:
		if (LOWORD(wParam) == IDC_STATIC_LINK)
		{
			ShellExecute(NULL, "open", "http://netston.tripod.com", 
				                                           0, 0, SW_SHOWNORMAL);
		}
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}

LRESULT APIENTRY StaticSubclassedFunc(HWND hWnd, UINT Message, WPARAM wParam, 
				LONG lParam)
{
    SetCursor(LoadCursor(NULL, IDC_HAND) );

    return CallWindowProc((WNDPROC)g_wpOldWndProc, hWnd, Message, wParam, 
	                                                                    lParam);
}

void AboutDlg_SetFont(HWND hWnd)
{
	HFONT hfnt;
	LOGFONT lf;

	// Specify the font to use (stored in a LOGFONT structure).
	lf.lfHeight = 16;
	lf.lfWidth = 0;
	lf.lfEscapement = 0;
	lf.lfOrientation = 0;
	lf.lfWeight = FW_DONTCARE;
	lf.lfItalic = FALSE;
	lf.lfUnderline = TRUE;
	lf.lfStrikeOut = FALSE;
	lf.lfCharSet = DEFAULT_CHARSET;
	lf.lfOutPrecision = OUT_DEFAULT_PRECIS;
	lf.lfClipPrecision = CLIP_DEFAULT_PRECIS;
	lf.lfQuality = DEFAULT_QUALITY;
	lf.lfPitchAndFamily = FF_DONTCARE;
	_tcsncpy(lf.lfFaceName, _T("Arial") /*_T("MS Shell Dlg")*/, 32);

	hfnt = CreateFontIndirect(&lf);
	SendMessage(GetDlgItem(hWnd, IDC_STATIC_LINK),  WM_SETFONT, (WPARAM)hfnt, TRUE);
}

// NOTES: The method to get version information from CHM file is the following.
//        CHM file is compiled with GetCHMVersion_Version_1.0.htm file the sole 
//        purpose of which is to keep in its name CHM version information. The 
//        content of CHM file is opened with ReadFile, and then is searched for 
//        the "GetCHMVersion_Version_1.0.htm" string. Due to the fact that CHM 
//        file contains typically many NUL characters is search is conducted 
//        with memchr (not with strchr or strstr).
BOOL AboutDlg_OnInitDialog(HWND hDlg)
{
	// Help file is supposed to reside in the project root folder while the 
    // executable is in Release or Debug folder.
	char szCHMFileName[] = "..\\GetCHMVersion.chm"; 
	int  ch = 'G';  // search character
	HANDLE hCHMFile;
	// The buffer should be big enough to hold characters beyond the 
	// "GetCHMVersion_Version_1.0.htm" string in CHM file, but generally less 
	// than CHM file size. 
	char szBuffer[2000]; 
	DWORD dwBytesToRead = sizeof(szBuffer);
	DWORD dwRead;
	LPBYTE  lpCurr = NULL;
	int nSearchDepth;
	int nNextPos;
	LPBYTE  lpStart = NULL;
	char szTarget[100];
	char szVersion[10];
	char* pszVersion = NULL;
	BOOL bFound = FALSE;

	hCHMFile = CreateFile(szCHMFileName, GENERIC_READ, 
	    FILE_SHARE_READ, NULL /* security is off */,          
		OPEN_EXISTING /* opens file if exists, fails if does not */,
		                          FILE_ATTRIBUTE_NORMAL /* normal use */, NULL);

	if (hCHMFile != INVALID_HANDLE_VALUE)
	{
		ReadFile(hCHMFile, szBuffer /* out */, dwBytesToRead /* in */, 
			                                           &dwRead /* out */, NULL);

		// Since the szBuffer contains many NUL characters, memchr is used to 
		// search for "GetCHMVersion_Version_<x.x>.htm" string. The memchr-
		// search is enabled up to the end of the buffer (an exact position 
		// where the search must be ended is not essential).
		nSearchDepth = sizeof(szBuffer); 
		lpCurr	= (LPBYTE)memchr(szBuffer, ch, nSearchDepth);
		// Return FALSE if the search character was not found.
		if (lpCurr == NULL) return FALSE;
        // Calculate the position next to the found character relative to the
		// beginning of the buffer.
		nNextPos = (int)((char*)lpCurr - szBuffer + 1);

        while (nSearchDepth > 0)
		{
			// The new position to start search.
			lpStart = lpCurr + 1;
			// The size of remaining chunk of characters that were not searched.
			nSearchDepth = nSearchDepth - nNextPos;
			lpCurr	= (LPBYTE)memchr(lpStart, ch, nSearchDepth);
			// Return FALSE if the search character was not found.
		    if (lpCurr == NULL) return FALSE;
			nNextPos = (int)((char*)lpCurr - (char*)lpStart + 1);

			// Check if found position corresponds to 
			// "GetCHMVersion_Version_<x.x>.htm" string, get the version, and if 
			// not, continue the search. First, extract the 29 characters that 
			// might be "GetCHMVersion_Version_<x.x>.htm" string (without NUL 
			// since anyway szTarget is NUL-terminated when initialized).
			strncpy(szTarget, (char*)lpCurr, 29); 
			if (strncmp(szTarget, "GetCHMVersion_Version_", 22) == 0 /* equal */) 
			{
				bFound = TRUE;
				break; 
			}
		}

        if (bFound)
		{
			// Get the version string that is in <x.x> format.
			pszVersion = szTarget + 22;
			*(pszVersion + 3)  = '\0';
			strcpy(szVersion, pszVersion);

            // Show the version string in the About dialog.
			SendMessage(GetDlgItem(hDlg, IDC_ABOUT_STATIC_VERSION), 
							   WM_SETTEXT, 0 /* not used */, (LPARAM)szVersion);
			return TRUE;
		}

		CloseHandle(hCHMFile); 
	}
	else
	{
        //DWORD nErr = GetLastError();
		MessageBox(NULL, "CHM Help file was not found.", "CHM Version", 
			                                                MB_ICONINFORMATION);
	}

	return FALSE; // either CHM file or version string is not found 
}
